!--------------------------------------------------------------------------
! (c) 1996 thru 2003 by
! Tinman Development Corporation
!                And
! Reichenberger Development Incorporated
! All Rights Reserved World Wide
! ISBN: 0-933735-17-0
! 
!--------------------------------------------------------------------------
TIN_REPORTVIEWER  FUNCTION(Reportin,PrintPreviewQueue,Titlein)

CurrentPage                    LONG
PagesAcross                    LONG
PagesDown                      LONG
DisplayedPagesAcross           LONG
DisplayedPagesDown             LONG

ZoomNoZoom                     BYTE
ZoomPageWidth                  BYTE
Zoom50                         BYTE
Zoom75                         BYTE
Zoom100                        BYTE
Zoom200                        BYTE
Zoom300                        BYTE
ZoomModifier                   REAL

PopupSelection                 BYTE
PopupText                      STRING(56)

ThumbnailsPresent              LONG
ZoomPresent                    BYTE

TemporaryImage                   EQUATE(100)
ZoomBorder                       EQUATE(101)
ZoomImage                        EQUATE(102)
LowestBorderEquate               EQUATE(104)
LowestImageEquate                EQUATE(204)
HighestControlEquate             EQUATE(404)
MinimumXSeparation               EQUATE(3)
MinimumYSeparation               EQUATE(3)
ReturnValue                      BYTE

ImageCount                       LONG
ImageWidth                       LONG
ImageHeight                      LONG
ImageAspectRatio                 REAL

ThumbnailsRequired               LONG
CurrentThumbnail                 LONG
ThumbnailXPosition               LONG
ThumbnailYPosition               LONG
ThumbnailHeight                  LONG
ThumbnailWidth                   LONG
ThumbnailAspectRatio             REAL
ThumbnailRow                     LONG
ThumbnailColumn                  LONG

ProcessedPage                    LONG

PageZoom                         REAL

CurrentImageBox                  LONG
CurrentBorderBox                 LONG

TotalXSeparation                 LONG
TotalYSeparation                 LONG

PreviewWindowX                   STRING(20)
PreviewWindowY                   STRING(20)
PreviewWindowWidth               STRING(20)
PreviewWindowHeight              STRING(20)

Zoomed                           BYTE
ZoomRatio                        STRING(20)

ClickedControl                   LONG

!--------------------TINMAN SOFTWARE CORP.----------------------------------
PageMarked           LONG(0)
OptionPrint          BYTE
PageFrom             LONG(1)
PageTo               LONG(1)
PREVIEWCOPIES        LONG(1)
PREVIEWPRINTER       STRING(50)
PREVIEWCOLLATE       BYTE
PREVIEWSAVEFILE      BYTE
PREVIEWFILENAME      STRING(100)
PAGENUMOFWRK         STRING(19)
LOCALRESPONSE        LONG

PREV:MetaFileName    string(100),Static
PREV:Metafile   FILE,DRIVER('dos'),NAME(PREV:MetaFileName)
Record            RECORD,PRE()
MetaLine           STRING(256)
                  END
                END

PREV:TxtFileName        STRING(100),STATIC
PREV:Txtfile        FILE,DRIVER('ASCII'),NAME(PREV:TxtFileName),PRE(PTXT),CREATE
Record                RECORD,PRE()
Line                    STRING(220)
                      END
                    END

MarkQueue       QUEUE,PRE(MQ)
Mark              BYTE
                END
!--------------------TINMAN SOFTWARE CORP.----------------------------------

Preview:Window WINDOW('Pregled'),AT(,,316,200),FONT('MS Sans Serif',10,,),COLOR(COLOR:Gray),IMM, |
         ICON(Icon:Print),ALRT(PgUpKey),ALRT(PgDnKey),ALRT(UpKey),ALRT(DownKey),ALRT(LeftKey),ALRT(RightKey), |
         STATUS(150,50,50,50,-1),GRAY,MAX,MAXIMIZE,RESIZE,AUTO,MDO
       TOOLBAR,AT(0,0,316,17)
         BUTTON,AT(2,2,14,14),USE(?PrintButton),MSG('Print The Report'),TIP('Print The Report'),ICON(ICON:Print)
         BUTTON,AT(18,2,14,14),USE(?ExitButton),MSG('Exit Without Printing Report'),TIP('Exit Without Printing Report'), |
             ICON(ICON:NoPrint)
         BUTTON,AT(163,2,14,14),USE(?ZoomButton),MSG('Zoom in on a page'),TIP('Zoom in on a page '),ICON(ICON:Zoom)
         BUTTON,AT(114,2,14,14),USE(?JUMP),MSG('Jump To Page ??'),TIP('Jump To Page ??'),ICON(ICON:JumpPage)
         BUTTON,AT(98,2,14,14),USE(?PREVIEWBOTTOM),MSG('Go To Last Page'),TIP('Go To Last Page'),ICON(ICON:VCRbottom)
         BUTTON,AT(82,2,14,14),USE(?NEXT),MSG('Next Page'),TIP('Next Page'),ICON(ICON:VCRplay)
         BUTTON,AT(66,2,14,14),USE(?PREVIOUS),MSG('Previous Page'),TIP('Previous Page'),ICON(ICON:VCRback)
         BUTTON,AT(50,2,14,14),USE(?PREVIEWTOP),MSG('Go To First Page'),TIP('Go To First Page'),ICON(ICON:VCRtop)
         BUTTON,AT(34,2,14,14),USE(?Button4),ICON(ICON:Print1)
         PROMPT('&Across:'),AT(222,2)
         SPIN(@N2),AT(248,2,20,10),USE(PagesAcross),VSCROLL,MSG('Select the number of thumbnails in a row'), |
             RANGE(1,10),STEP(1)
         PROMPT('&Down:'),AT(270,1)
         SPIN(@n2),AT(293,2,20,10),USE(PagesDown),MSG('Select the number of thumbnails in a column'), |
             RANGE(1,10),STEP(1)
         BUTTON,AT(180,2,14,14),USE(?CHANGEDISPLAY),ICON(ICON:Thumbnail)
         BUTTON,AT(146,2,14,14),USE(?PREVIEWDELETE),MSG('Delete Page'),TIP('Delete Page'),ICON(ICON:Cut)
         BUTTON,AT(130,2,14,14),USE(?PREVIEWMARK),MSG('Mark Page For Printing'),TIP('Mark / Unmark Page For Printing'), |
             ICON(ICON:Tick)
       END
     END

!--------------------TINMAN SOFTWARE CORP.----------------------------------
PrintWindow WINDOW('Print Options'),AT(,,149,101),FONT('MS Sans Serif',8,,FONT:regular),CENTER,GRAY
       STRING('To:'),AT(69,58),FONT('Arial',8,,FONT:regular)
       SPIN(@N_3B),AT(81,60,20,8),USE(PAGETO),FONT('Arial',8,,FONT:regular),MSG('Select Ending Page'), |
           TIP('Select Ending Page'),RANGE(1,999),STEP(1)
       STRING('From:'),AT(26,58),FONT('Arial',8,,FONT:regular)
       SPIN(@N_3B),AT(45,60,20,8),USE(PAGEFROM),FONT('Arial',8,,FONT:regular),MSG('Select Starting Page'), |
           TIP('Select Starting Page'),RANGE(1,999),STEP(1)
       OPTION('Print Ranges'),AT(18,7,121,65),USE(OptionPrint),BOXED,FONT('Arial',9,,FONT:regular)
         RADIO('All Pages'),AT(23,16),MSG('Print All Pages'),TIP('Print All Pages'),VALUE('1')
         RADIO('Marked Pages Only'),AT(23,26),USE(?OptionPrint:Marked),DISABLE,MSG('Print Marked Pages Only'), |
             TIP('Print Mark Pages Only'),VALUE('2')
         RADIO('Unmarked Pages Only'),AT(23,36),USE(?OptionPrint:UnMarked),DISABLE,MSG('Print Unmarked Pages Only'), |
             TIP('Print Unmarked Pages Only'),VALUE('3')
         RADIO('Range of Pages'),AT(23,46),MSG('Print A Range Of Pages'),TIP('Print A Range Of Pages'), |
             VALUE('4')
       END
       PANEL,AT(0,-1,149,102),USE(?Panel1),BEVEL(6)
       BUTTON('OK'),AT(27,80,32,10),USE(?PrintOK),FONT('Arial',8,,FONT:regular),DEFAULT
       BUTTON('Cancel'),AT(78,80,32,10),USE(?PrintCancel),FONT('Arial',8,,FONT:regular)
     END

PPQueue QUEUE,PRE(ppq)
PPImage   STRING(80)
        END

PrevReport REPORT,AT(1000,2000,6000,7000),PRE(RPT),THOUS
detail DETAIL
       END
     END

   CODE

   ReturnValue       = False


   MQ:Mark = 0
   LOOP Records(PrintPreviewQueue) Times
     ADD(MarkQueue)
   .
   SETCURSOR(CURSOR:WAIT)
   DISPLAY()
!--------------------TINMAN SOFTWARE CORP.----------------------------------
   OPEN(Preview:Window)
!--------------------TINMAN SOFTWARE CORP.----------------------------------
   !INIRestoreWindow('ReportViewerWindow','TINTOOLS.INI')
   IF ~OMITTED(2) AND CLIP(TITLEIN) <> '' THEN
     Preview:Window{Prop:Text} = CLIP(TITLEIN)
   .
!--------------------TINMAN SOFTWARE CORP.----------------------------------
   TARGET{Prop:MinWidth} = 315
   ! Retrieve first image to get image aspect ratio, then destroy the image
   GET(PrintPreviewQueue,1)
   CREATE(TemporaryImage,CREATE:Image)
   TemporaryImage{Prop:Text} = PrintPreviewQueue
   ImageWidth = TemporaryImage{Prop:MaxWidth}
   ImageHeight = TemporaryImage{Prop:MaxHeight}
   ImageAspectRatio = ImageHeight / ImageWidth
   DESTROY(TemporaryImage)
   ImageCount           = RECORDS(PrintPreviewQueue)
   CurrentPage          = 1
   PagesAcross          = 1
   PagesDown            = 1
   PagesDown            = 1
   DisplayedPagesAcross = 0
   DisplayedPagesDown   = 0
   ThumbnailsPresent    = 0
   ZoomPresent          = False
!!!!
   IF ImageCount = 1
 !    DISABLE(?ViewMenu)
   END
!!!!
   ZoomNoZoom          = True
   DO CHECKFORPAGENUM
   SETCURSOR()
   DISPLAY
   DO ChangeDisplay
   ACCEPT
     CASE EVENT()
     OF Event:Sized
       DO ChangeDisplay
     OF Event:NewSelection
       CASE FIELD()
       OF ?PagesAcross
       OROF ?PagesDown
         DO ClearZoomValues
         ZoomNoZoom = True
         DO ChangeDisplay
       END
     OF Event:Rejected
       CASE REJECTCODE()
       OF Reject:RangeHigh
         CHANGE(FIELD(),FIELD(){Prop:RangeHigh})
       OF Reject:RangeLow
         CHANGE(FIELD(),FIELD(){Prop:RangeLow})
       END
       DO ChangeDisplay
     OF Event:AlertKey
       CASE KEYCODE()
       OF PgUpKey
         POST(Event:Accepted,?Previous)
       OF PgDnKey
         POST(Event:Accepted,?Next)
       OF DownKey
         MTSaveVPos# = ZoomImage{prop:vScrollPos}
         ZoomImage{prop:vScrollPos} = MTSaveVPos# + 51
       OF UpKey
         MTSaveVPos# = ZoomImage{prop:vScrollPos}
         ZoomImage{prop:vScrollPos} = MTSaveVPos# - 51
       OF LeftKey
         MTSaveHPos# = ZoomImage{prop:hScrollPos}
         ZoomImage{prop:hScrollPos} = MTSaveHPos# - 52
       OF RightKey
         MTSaveHPos# = ZoomImage{prop:hScrollPos}
         ZoomImage{prop:hScrollPos} = MTSaveHPos# + 52
       ELSE
         CASE FIELD()
         OF ZoomImage
           DO ClearZoomValues
           ZoomNoZoom = True
           DO ChangeDisplay
         ELSE
           CurrentPage = (FIELD() - LowestImageEquate) + CurrentPage
           ZoomNoZoom = False
           ZoomPageWidth = True
           DO ChangeDisplay
         END
       END
     OF Event:Accepted
       CASE FIELD()
       OF ?PrintButton
         DO PRINTREPORT
         IF ~RETURNVALUE THEN
           CYCLE
         ELSE
         .
         POST(Event:CloseWindow)
         ReturnValue = True
       OF ?ExitButton
         POST(Event:CloseWindow)
       OF ?ZoomButton
!                              1         2         3         4         5
!                     123456789012345678901234567890123456789012345678901234567890
         PopupText = '-No Zoom|-|-Page Width|-50%%|-75%%|-100%%|-200%%|-300%%'
         IF ZoomNoZoom
           PopupText[1] = '+'
         ELSIF ZoomPageWidth
           PopupText[12] = '+'
         ELSIF Zoom50
           PopupText[24] = '+'
         ELSIF Zoom75
           PopupText[30] = '+'
         ELSIF Zoom100
           PopupText[36] = '+'
         ELSIF Zoom200
           PopupText[43] = '+'
         ELSIF Zoom300
           PopupText[50] = '+'
         END
         PopupSelection = POPUP(PopupText)
         IF PopupSelection
           DO ClearZoomValues
           EXECUTE(PopupSelection)
             ZoomNoZoom = True
             ZoomPageWidth = True
             Zoom50 = True
             Zoom75 = True
             Zoom100 = True
             Zoom200 = True
             Zoom300 = True
           END
           DO ChangeDisplay
         END
       OF ?Next
         DO GetNextPage
         DO ChangeDisplay
       OF ?Previous
         DO GetPrevPage
         DO ChangeDisplay
       OF ?Jump
         CurrentPage = TIN_Preview:JumpToPage(CurrentPage,ImageCount)
         DO ChangeDisplay
       OF ?ChangeDisplay
         TIN_Preview:SelectDisplay(PagesAcross,PagesDown)
         DO ChangeDisplay
!--------------------TINMAN SOFTWARE CORP.----------------------------------
       OF ?PreviewTop
         CurrentPage = 1
         POST(Event:Accepted,?Previous)
       OF ?PreviewBottom
         CurrentPage = ImageCount
         POST(Event:Accepted,?Next)
        OF ?PREVIEWMARK
          IF ~ZoomNoZoom OR (PagesAcross = 1 AND PagesDown = 1)
            DO MarkPage
          .
        OF ?PREVIEWDELETE
          IF ~ZoomNoZoom OR (PagesAcross = 1 AND PagesDown = 1)
            DO DeletePage
            DO ChangeDisplay
          .
!--------------------TINMAN SOFTWARE CORP.----------------------------------
       END
     END
   END
   IF ReturnValue
     GlobalResponse = RequestCompleted
   ELSE
     GlobalResponse = RequestCancelled
   END
!--------------------TINMAN SOFTWARE CORP.----------------------------------
   !INISaveWindow('ReportViewerWindow','TINTOOLS.INI')
   CLOSE(Preview:Window)
   FREE(MarkQueue)
!--------------------TINMAN SOFTWARE CORP.----------------------------------
   RETURN(GLOBALRESPONSE)

!------------------------------------------------------

!------------------------------------------------------
ChangeDisplay ROUTINE
!|
!| This routine is called to select the current display mode of the ReportPreview
!| window.
!|
!| If any zooming is being done (ZoomNoZoom = False) then any thumbnails present
!| are destroyed. If the Zoom control is not present, it is created. Finally, the
!| Zoom control is filled with the current page and zoomed.
!|
!| If no zooming is being done, then the Zoom control, if present, is destroyed.
!| Next, if the number of pages to be displayed has changed, then any existing
!| thumbnails are destroyed, and the new thumbnails are created. Finally, the
!| thumbnails are positioned and filled.
!|
  IF ZoomNoZoom
    IF ZoomPresent
      DO DestroyZoomControl
    END
    IF PagesDown <> DisplayedPagesDown OR PagesAcross <> DisplayedPagesAcross
      IF ThumbnailsPresent
        DO DestroyThumbnails
      END
      DO CreateThumbnails
      DisplayedPagesDown = PagesDown
      DisplayedPagesAcross = PagesAcross
    END
    DO PositionThumbnails
    DO FillThumbnails
    TARGET{Prop:StatusText,2} = 'No Zoom'
!--------------------TINMAN SOFTWARE CORP.----------------------------------
    IF (PagesAcross = 1 AND PagesDown = 1)
      Do CheckMark
    .
!--------------------TINMAN SOFTWARE CORP.----------------------------------
  ELSE
    IF ThumbnailsPresent
      DO DestroyThumbnails
    END
    IF NOT ZoomPresent
      DO CreateZoomControl
    END
    DO FillZoomControl
    DisplayedPagesAcross = 0
    DisplayedPagesDown   = 0
!--------------------TINMAN SOFTWARE CORP.----------------------------------
    Do CheckMark
!--------------------TINMAN SOFTWARE CORP.----------------------------------
  END
! DISPLAY(?ZoomNoZoom,?Zoom300)
  DISPLAY(?PagesDown)

!------------------------------------------------------
CreateZoomControl ROUTINE
!|
!| This routine is used to create the Zoom control and its background.
!|
  CREATE(ZoomBorder,CREATE:Box)
  SETPOSITION(ZoomBorder,0,0)
  ZoomBorder{Prop:Color} = 0
  ZoomBorder{Prop:Fill} = 0FFFFFFh
  ZoomBorder{Prop:Full} = True
  UNHIDE(ZoomBorder)
  CREATE(ZoomImage,CREATE:Image)
  SETPOSITION(ZoomImage,0,0)
  ZoomImage{Prop:VScroll} = True
  ZoomImage{Prop:HScroll} = True
  ZoomImage{Prop:Full} = True
  ZoomImage{Prop:FillColor} = 0FFFFFFh    !***This statement was missing***
  ZoomImage{Prop:Alrt} = MouseLeft
  ZoomImage{Prop:Cursor} = Cursor:Zoom
  UNHIDE(ZoomImage)
  ZoomPresent = True

!------------------------------------------------------
DestroyZoomControl ROUTINE
!|
!| This routine is used to destroy the zoom control and its background.
!|
  HIDE(ZoomBorder)
  HIDE(ZoomImage)
  DESTROY(ZoomBorder)
  DESTROY(ZoomImage)
  ZoomPresent = False

!------------------------------------------------------
FillZoomControl ROUTINE
!|
!| This routine is used to fill the Zoom control with an image, and to set the
!| image's zoom ration to the correct value.
!|
  MTSaveVPos# = ZoomImage{prop:vScrollPos}
  MTSaveHPos# = ZoomImage{prop:hScrollPos}
  DO ConfigureZoomRatio
  GET(PrintPreviewQueue,CurrentPage)
  ZoomImage{Prop:Text} = PrintPreviewQueue
  TARGET{Prop:StatusText,5} = 'Page ' & CurrentPage & ' of ' & ImageCount
  ZoomImage{Prop:MaxWidth} = ImageWidth * ZoomModifier
  ZoomImage{Prop:MaxHeight} = ImageHeight * ZoomModifier
  ZoomImage{prop:vScrollPos} = MTSaveVPos#
  ZoomImage{prop:hScrollPos} = MTSaveHPos#
  IF ImageCount > 1
    IF CurrentPage = 1
      DISABLE(?Previous)
    ELSE
      ENABLE(?Previous)
    END
    IF CurrentPage > ImageCount
      DISABLE(?Next)
    ELSE
      ENABLE(?Next)
    END
  END

!------------------------------------------------------
GetNextPage ROUTINE
!|
!| This routine increments the CurrentPage variable so that the next
!| "page" of images are displayed.
!|
   IF ZoomNoZoom
     IF CurrentPage + ThumbnailsPresent <= ImageCount
       CurrentPage += ThumbnailsPresent
     END
   ELSE
     IF CurrentPage <> ImageCount
       CurrentPage += 1
     END
   END

!------------------------------------------------------
GetPrevPage ROUTINE
!|
!| This routine decrements the CurrentPage variable so that the previous
!| "page" of images are displayed.
!|
   IF ZoomNoZoom
     CurrentPage -= ThumbnailsPresent
     IF CurrentPage < 1
       CurrentPage = 1
     END
   ELSE
     IF CurrentPage <> 1
       CurrentPage -= 1
     END
   END

!------------------------------------------------------
CreateThumbnails ROUTINE
!|
!| This routine is used to create all thumbnail images and their backgrounds
!|
   ZoomRatio = 'No Zoom'
   CurrentBorderBox = LowestBorderEquate
   CurrentImageBox = LowestImageEquate
   ThumbnailsRequired = (PagesAcross * PagesDown)
   LOOP CurrentThumbnail = 1 TO ThumbnailsRequired
     CREATE(CurrentBorderBox,CREATE:Box)
     CREATE(CurrentImageBox,CREATE:Image)
     CurrentBorderBox += 1
     CurrentImageBox += 1
   END
   ThumbnailsPresent = ThumbnailsRequired

!------------------------------------------------------
DestroyThumbnails ROUTINE
!|
!| This routine is used to destroy all thumbnail images and their backgrounds
!|
   HIDE(LowestBorderEquate,HighestControlEquate)
   DESTROY(LowestImageEquate,HighestControlEquate)
   ThumbnailsPresent = 0

!------------------------------------------------------
PositionThumbnails ROUTINE
!|
!| This routine is used to position all of the thumbnails and their backgrounds.
!|
   TotalXSeparation = 2 + ((PagesAcross - 1) * MinimumXSeparation)
   TotalYSeparation = 2 + ((PagesDown - 1) * MinimumYSeparation)
   ThumbnailWidth = (TARGET{Prop:Width} - TotalXSeparation) / PagesAcross
   ThumbnailHeight = ((TARGET{Prop:Height} -18) - TotalYSeparation) / PagesDown
   ThumbnailAspectRatio = ThumbnailHeight / ThumbnailWidth
   IF ThumbnailAspectRatio < ImageAspectRatio
     ThumbnailWidth = ThumbnailHeight / ImageAspectRatio
   ELSE
     ThumbnailHeight = ThumbnailWidth * ImageAspectRatio
   END
   CurrentBorderBox = LowestBorderEquate
   CurrentImageBox = LowestImageEquate
   ThumbnailYPosition = 1
   LOOP ThumbnailRow = 1 TO PagesDown
     ThumbnailXPosition = 1
     LOOP ThumbnailColumn = 1 TO PagesAcross
       SETPOSITION(CurrentBorderBox,ThumbnailXPosition,ThumbnailYPosition,ThumbnailWidth,ThumbnailHeight)
       SETPOSITION(CurrentImageBox,ThumbnailXPosition,ThumbnailYPosition,ThumbnailWidth,ThumbnailHeight)
       CurrentBorderBox{Prop:Color} = 0
       CurrentBorderBox{Prop:Fill} = 0FFFFFFh
       CurrentImageBox{Prop:Cursor} = Cursor:Zoom
       CurrentImageBox{Prop:Alrt} = MouseLeft
       ThumbnailXPosition += MinimumXSeparation + ThumbnailWidth
       CurrentBorderBox += 1
       CurrentImageBox += 1
     END
     ThumbnailYPosition += MinimumYSeparation + ThumbnailHeight
   END

!------------------------------------------------------
FillThumbnails ROUTINE
!|
!| This routine is used to fill all of the thumbnails.
!|
   CurrentBorderBox = LowestBorderEquate
   CurrentImageBox = LowestImageEquate
   LOOP CurrentThumbnail = 1 TO ThumbnailsPresent
     ProcessedPage = (CurrentPage + CurrentThumbnail) - 1
     IF ProcessedPage > ImageCount
       IF CurrentImageBox{Prop:Hide} = False
         HIDE(CurrentBorderBox)
         HIDE(CurrentImageBox)
       END
     ELSE
       GET(PrintPreviewQueue,ProcessedPage)
       CurrentImageBox{Prop:Text} = PrintPreviewQueue
       IF CurrentImageBox{Prop:Hide} = True
         UNHIDE(CurrentBorderBox)
         UNHIDE(CurrentImageBox)
       END
     END
     CurrentBorderBox += 1
     CurrentImageBox += 1
   END
   IF ImageCount > 1
     IF CurrentPage = 1
       DISABLE(?Previous)
     ELSE
       ENABLE(?Previous)
     END
     IF CurrentPage + ThumbnailsPresent > ImageCount
       DISABLE(?Next)
     ELSE
       ENABLE(?Next)
     END
   END
   IF ThumbnailsPresent > 1
     ProcessedPage = CurrentPage + ThumbnailsPresent - 1
     IF ProcessedPage > ImageCount
       ProcessedPage = ImageCount
     END
     IF CurrentPage = ImageCount
       TARGET{Prop:StatusText,5} = 'Page ' & CurrentPage & ' of ' & ImageCount
     ELSE
       TARGET{Prop:StatusText,5} = 'Pages ' & CurrentPage & '-' & ProcessedPage & ' of ' & ImageCount
     END
   ELSE
     TARGET{Prop:StatusText,5} = 'Page ' & CurrentPage & ' of ' & ImageCount
   END
!------------------------------------------------------
ConfigureZoomRatio        ROUTINE
!|
!| This routine is used to set the Zoom modifier, and to set the status bar
!| text which displays the current zoom mode.
!|
  IF ZoomPageWidth
    ZoomModifier = TARGET{Prop:Width} / ImageWidth
    ZoomImage{Prop:HScroll} = False
    TARGET{Prop:StatusText,2} = 'Page Width'
  ELSIF Zoom50
    ZoomModifier = .50
    ZoomImage{Prop:HScroll} = True
    TARGET{Prop:StatusText,2} = 'Zoom (50%%)'
  ELSIF Zoom75
    ZoomModifier = .75
    ZoomImage{Prop:HScroll} = True
    TARGET{Prop:StatusText,2} = 'Zoom (75%%)'
  ELSIF Zoom100
    ZoomModifier = 1
    ZoomImage{Prop:HScroll} = True
    TARGET{Prop:StatusText,2} = 'Zoom (100%%)'
  ELSIF Zoom200
    ZoomModifier = 2
    ZoomImage{Prop:HScroll} = True
    TARGET{Prop:StatusText,2} = 'Zoom (200%%)'
  ELSIF Zoom300
    ZoomModifier = 3
    ZoomImage{Prop:HScroll} = True
    TARGET{Prop:StatusText,2} = 'Zoom (300%%)'
  END

!---------------------------------------------------------
ClearZoomValues ROUTINE
!|
!| Since the zoom status is kept in seven different flags, this routine
!| is used to clear all of the flags during any zoom mode change.
!|
  ZoomNoZoom    = False
  ZoomPageWidth = False
  Zoom50        = False
  Zoom75        = False
  Zoom100       = False
  Zoom200       = False
  Zoom300       = False

!--------------------TINMAN SOFTWARE CORP.----------------------------------
MarkPage ROUTINE
  IF MQ:Mark
    PageMarked -= 1
    MQ:Mark = False
  ELSE
    PageMarked += 1
    MQ:Mark = True
  .
  PUT(MarkQueue)
  DO CHECKMARK

CheckMark ROUTINE
  GET(MarkQueue,CURRENTPAGE)
  IF MQ:Mark
    ?PREVIEWMARK{Prop:ICON} = ICON:CROSS
    ?PREVIEWMARK{Prop:Msg}  = 'Unmark Page'
    Preview:Window{Prop:StatusText,4} = 'Marked'
  ELSE
    ?PREVIEWMARK{Prop:ICON} = ICON:TICK
    ?PREVIEWMARK{Prop:Msg}  = 'Mark Page'
    Preview:Window{Prop:StatusText,4} = ''
  .

DeletePage ROUTINE
  GET(PrintPreviewQueue,CURRENTPAGE)
  GET(MarkQueue,CURRENTPAGE)
  DELETE(PrintPreviewQueue)
  DELETE(MarkQueue)
  ImageCount -= 1
  IF CURRENTPAGE <> 1 THEN CURRENTPAGE -= 1.

PrintReport     ROUTINE
  OPTIONPRINT = 1
  OPEN(PrintWindow)
  IF PageMarked
    ?OptionPrint:Marked{Prop:Disable} = False
    ?OptionPrint:UnMarked{Prop:Disable} = False
  .
  ?PageFrom{Prop:RangeHigh} = RECORDS(PrintPreviewQueue)
  ?PageTo{Prop:RangeHigh}   = RECORDS(PrintPreviewQueue)
  ACCEPT
    IF OPTIONPRINT = 4 THEN
      ?PageFrom{Prop:Disable} = False
      ?PageTo{Prop:Disable}   = False
    ELSE
      ?PageFrom{Prop:Disable} = True
      ?PageTo{Prop:Disable}   = True
    END
    CASE ACCEPTED()
      OF ?OptionPrint
      OF ?PrintOK
         ReturnValue = True
        POST(Event:CloseWindow)
      OF ?PrintCancel
         ReturnValue = False
        POST(Event:CloseWindow)
    END
  END
  IF RETURNVALUE AND OptionPrint <> 1
    DO DiscardPages
  .
  CLOSE(PrintWindow)

DiscardPages        ROUTINE
  LOOP IDiscard# = RECORDS(PrintPreviewQueue) TO 1 BY -1
    IF OptionPrint = 2 OR OptionPrint = 3
      GET(MarkQueue,IDiscard#)
      IF(OptionPrint = 2 AND MQ:Mark) |
      OR(OptionPrint = 3 AND NOT MQ:Mark)
        CYCLE
      .
    ELSE
      IF IDiscard# >= PageFrom AND IDiscard# <= PageTo
        CYCLE
    . .
    GET(PrintPreviewQueue,IDiscard#)
    PREV:MetaFileName = PrintPreviewQueue
    REMOVE(PREV:MetaFile)
    DELETE(PrintPreviewQueue)
  END

CHECKFORPAGENUM ROUTINE
  LOOP TKCounter1# = 1 to ImageCount
    GET(PrintPreviewQueue, TKCounter1#)
    PREV:MetaFileName = PrintPreviewQueue
    OPEN(PREV:MetaFile)
    IF ERRORCODE(); CYCLE.
    TKMetaPointer# = 0
    LOOP
      SET(PREV:MetaFile, TKMetaPointer#)
      NEXT(PREV:MetaFile)
      TKCounter2# = instring('Page xxxxx of xxxxx', MetaLine, 1, 1)
      IF TKCounter2# > 0
        PAGENUMOFWRK = 'Page ' & FORMAT(TKCounter1#,@s5)
        PAGENUMOFWRK = CLIP(PAGENUMOFWRK) & ' of ' & FORMAT(ImageCount,@s5)
!        stop(PAGENUMOFWRK)
        PAGENUMOFWRK = CENTER(CLIP(PAGENUMOFWRK),19)
!        stop(PAGENUMOFWRK)
!        BREAK
        MetaLine = SUB(MetaLine,1,TKCounter2#-1)|
                     & PAGENUMOFWRK |
                     & SUB(MetaLine,TKCounter2#+19,LEN(MetaLine))
        PUT(PREV:MetaFile)
        BREAK
      END
      IF ERRORCODE() OR EOF(PREV:MetaFile); BREAK.
      TKMetaPointer# = POINTER(PREV:MetaFile) + 236     !This was originally   + 245
    END
    CLOSE(PREV:MetaFile)
  END
!--------------------------------------------------------------------------
TIN_Preview:JumpToPage FUNCTION(LONG Input:CurrentPage, LONG Input:TotalPages)
JumpPage    LONG
ReturnPage  LONG
JumpWindow WINDOW('Jump to a Report Page'),AT(,,181,26),FONT('MS Sans Serif',10,,),CENTER,STATUS,GRAY
       PROMPT('&Page:'),AT(5,8),USE(?JumpPrompt)
       SPIN(@n5),AT(30,7,50,12),MSG('Select a page of the report'),USE(JumpPage),STEP(1)
       BUTTON('OK'),AT(89,7,40,12),MSG('Jump to the selected page'),USE(?OKButton),DEFAULT
       BUTTON('Cancel'),AT(134,7,40,12),MSG('Cancel this selection'),USE(?CancelButton)
     END
  CODE
  JumpPage   = Input:CurrentPage
  ReturnPage = Input:CurrentPage
  OPEN(JumpWindow)
  ?JumpPage{Prop:RangeLow} = 1
  ?JumpPage{Prop:RangeHigh} = Input:TotalPages
  ACCEPT
    CASE ACCEPTED()
    OF ?OKButton
      ReturnPage = JumpPage
      BREAK
    OF ?CancelButton
      BREAK
    END
  END
  CLOSE(JumpWindow)
  RETURN(ReturnPage)
!--------------------------------------------------------------------------
TIN_Preview:SelectDisplay PROCEDURE(*LONG Input:PagesAcross, *LONG Input:PagesDown)
SelectWindow WINDOW('Change the Report Display'),AT(,,141,64),FONT('MS Sans Serif',10,,),GRAY
       GROUP('Pages Displayed'),AT(3,2,135,43),USE(?Group1),BOXED
         GROUP('Across'),AT(7,10,62,32),BOXED
           SPIN(@N2),AT(13,22,50,12),USE(Input:PagesAcross),HSCROLL,RANGE(1,10),STEP(1)
         END
         GROUP('Down'),AT(72,10,62,32),BOXED
           SPIN(@N2),AT(79,22,50,12),USE(Input:PagesDown),HVSCROLL,RANGE(1,10),STEP(1)
         END
       END
       BUTTON('OK'),AT(98,47,40,14),KEY(EnterKey),USE(?OK),STD(STD:Close)
     END
  CODE
  OPEN(SelectWindow)
  ACCEPT
  END
  RETURN

TIN_Preview:PrintViewerOpt FUNCTION
TINPRINTOPTION1   BYTE(1)
TINCURPRINTER     STRING(50)
XXXCURPRINTER     STRING(50),OVER(TINCURPRINTER)
TINCOPIES         LONG(1)
TINCOLLATE        BYTE
TINSAVEFILE       BYTE
TINFILENAME       STRING(100)

Printoptwin WINDOW('Report Destination'),AT(,,240,92),CENTER,GRAY
       STRING('Current Printer:'),AT(80,13),FONT('Arial',8,,FONT:bold),USE(?String2)
       OPTION,AT(6,14,58,36),FONT('Arial',8,,FONT:regular),USE(TINPRINTOPTION1),BOXED
         RADIO('View Report'),AT(14,23),FONT('Arial',8,,FONT:regular),MSG('View The Report'),TIP('View The Report'), |
             USE(?TINPRINTOption1:Radio1),VALUE('1')
         RADIO('Print Report'),AT(14,33),FONT('Arial',8,,FONT:regular),MSG('Print The Report Without Viewing'), |
             TIP('Print The Report Without Viewing'),USE(?TINPRINTOPTION1:Radio2),VALUE('2')
       END
       STRING(@s50),AT(85,24),USE(XXXCURPRINTER)
       BUTTON('OK'),AT(24,69,44,13),FONT('Arial',8,,FONT:regular),MSG('Do It'),TIP('Do It'),USE(?OkPrtOpt), |
           DEFAULT
       BUTTON('Cancel'),AT(82,69,44,13),FONT('Arial',8,,FONT:regular),MSG('Cancel Report'),TIP('Cancel Report'), |
           USE(?CancelPrtOpt)
       BUTTON('Options'),AT(138,69),FONT('Arial',8,,FONT:regular),MSG('Select Options'),TIP('Select Options'), |
           USE(?TINPRINTSEL)
     END

PrintxxxWindow WINDOW('Print Options'),AT(,,250,99),FONT('System',8,,FONT:bold),CENTER,ICON(Icon:Print), |
         SYSTEM,GRAY
       OPTION('Copies / Collate'),AT(5,7,58,32),FONT('Arial',9,,FONT:regular),USE(?Option2),BOXED
       END
       SPIN(@N_3B),AT(28,19,20,8),FONT('Arial',8,,FONT:regular),MSG('Select Number Of Copies'),TIP('Select Number Of Copies'), |
           USE(TINCOPIES),RANGE(1,15),STEP(1)
       BUTTON,AT(226,13),MSG('Select A File'),TIP('Select A File'),USE(?PrintToFIle),ICON(ICON:Pick)
       CHECK('Collate'),AT(9,27),FONT('Arial',8,,FONT:regular),MSG('Collate Report Copies'),TIP('Collate Report Copies'), |
           USE(TINCOLLATE)
       ENTRY(@s60),AT(75,25),MSG('Enter File Name'),TIP('Enter File Name'),USE(TINFILENAME)
       ENTRY(@s50),AT(50,52),FONT('Arial',10,,FONT:bold),MSG('Current Printer Selected'),TIP('Current Printer Selected'), |
           USE(TINCURPRINTER),SKIP,READONLY
       STRING('Copies:'),AT(9,17),FONT('Arial',8,,FONT:regular)
       CHECK('Print To FIle'),AT(75,15),FONT('Arial',8,,FONT:regular),MSG('Print To FIle'),TIP('Print To FIle'), |
           USE(TINSAVEFILE)
       OPTION('Print To File'),AT(71,7,169,32),FONT('Arial',8,,FONT:regular),USE(?option3),BOXED
       END
       STRING('Current Printer:'),AT(6,50),FONT('Arial',9,,FONT:regular)
       BUTTON('OK'),AT(51,76,32,10),FONT('Arial',8,,FONT:regular),MSG('Accept Options'),TIP('Accept Options'), |
           USE(?PrintXXXOK),DEFAULT
       BUTTON('Cancel'),AT(99,76,32,10),FONT('Arial',8,,FONT:regular),MSG('Cancel'),TIP('Cancel'),USE(?PrintXXXCancel)
       BUTTON('Select'),AT(145,76,32,10),FONT('Arial',8,,FONT:regular),MSG('Select A Printer'),TIP('Select A Printer'), |
           USE(?PrintXXXSelect)
     END

  CODE

  TINPRINTOPTION1 = 1
  OPEN(Printoptwin)
  ACCEPT
    CASE ACCEPTED()
      OF ?OkPrtOpt
        PRINTER{PROPPRINT:COLLATE} = TINCOLLATE
        PRINTER{PROPPRINT:COPIES}  = TINCOPIES
        IF TINSAVEFILE THEN
        PRINTER{PROPPRINT:PRINTTOFILE} = TRUE
        PRINTER{PROPPRINT:PRINTTONAME} = CLIP(TINFILENAME)
        END
        POST(Event:CloseWindow)
      OF ?CancelPrtOpt
        TINPRINTOPTION1 = 3
        POST(Event:CloseWindow)
       OF ?TINPRINTSEL
        DO PRINTTINSELECT
     END
     XXXCURPRINTER =  PRINTER{PROPPRINT:Device}
     DISPLAY()
  END
  CLOSE(Printoptwin)
  RETURN(TINPRINTOPTION1)

PRINTTINSELECT ROUTINE
  OPEN(PrintXXXWindow)
  ACCEPT
    CASE ACCEPTED()
      OF ?PrintXXXOK
        POST(Event:CloseWindow)
      OF ?PrintXXXCancel
        POST(Event:CloseWindow)
      OF ?PRINTTOFILE
        IF FILEDIALOG('Select A File...', |
                       TINFILENAME, |
                       'Windows MetaFile|*.WMF', |
                       1)
        .
      OF ?PRINTXXXSELECT
        X# = PRINTERDIALOG('Select A Printer',1)
    END
    TINCURPRINTER = PRINTER{PROPPRINT:Device}
    DISPLAY()
  END
  CLOSE(PrintXXXWindow)
!--------------------TINMAN SOFTWARE CORP.----------------------------------

